package constants;

import java.net.InetAddress;
import java.net.UnknownHostException;

public abstract class Constants {
	public static int HEADER_MAX_SIZE = 88;
	public static int BODY_MAX_SIZE = 64000;
	public static int PACKET_MAX_SIZE = HEADER_MAX_SIZE + BODY_MAX_SIZE;
	public static int MC_PORT = 40121;
	public static int MDB_PORT = 40122;
	public static int MDR_PORT = 40123;
	public static final String SPACE = " ";
	private static InetAddress MC_ADDRESS = null;
	private static InetAddress MDB_ADDRESS = null;
	private static InetAddress MDR_ADDRESS = null;
	private static String IP_ADDRESS_1="239.254.254.121";
	private static String IP_ADDRESS_2="239.254.254.122";
	private static String IP_ADDRESS_3="239.254.254.123";
	private static final char CR = 13;
	private static final char LF = 10;
	public static String INITIAL_VERSION = "1.0";

	public static void set_header(int n)
	{
		HEADER_MAX_SIZE=n;
	}
	
	public static void set_body(int n)
	{
		BODY_MAX_SIZE=n;
	}
	
	public static void set_mc(int n)
	{
		MC_PORT=n;
	}
	
	public static void set_mdb(int n)
	{
		MDB_PORT=n;
	}
	
	public static void set_mdr(int n)
	{
		MDR_PORT=n;
	}
	
	public static void set_version(String s)
	{
		INITIAL_VERSION=s;
	}
	
	public static String CRLF()
	{
		char CRLF[] = new char[2];
		CRLF[0] = CR;
		CRLF[1] = LF;
		return new String(CRLF);
	}

	public static InetAddress MC_ADDRESS()
	{
		if( MC_ADDRESS == null )
		{
			try {
				MC_ADDRESS = InetAddress.getByName(IP_ADDRESS_1);
			} catch (UnknownHostException e) {
				e.printStackTrace();
			}
		}
		return MC_ADDRESS;
	}

	public static InetAddress MDB_ADDRESS()
	{
		if( MDB_ADDRESS == null )
		{
			try {
				MDB_ADDRESS = InetAddress.getByName(IP_ADDRESS_2);
			} catch (UnknownHostException e) {
				e.printStackTrace();
			}
		}
		return MDB_ADDRESS;
	}

	public static InetAddress MDR_ADDRESS()
	{
		if( MDR_ADDRESS == null )
		{
			try {
				MDR_ADDRESS = InetAddress.getByName(IP_ADDRESS_3);
			} catch (UnknownHostException e) {

				e.printStackTrace();
			}
		}
		return MDR_ADDRESS;
	}  
}