package file_system;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.util.ArrayList;
import java.util.HashMap;

import constants.Constants;

public class Stored_files {
	private HashMap<String,Files> stored_files_map;
	public static Stored_files stored_files = new Stored_files();

	@SuppressWarnings("unchecked")
	private Stored_files()
	{
		stored_files_map = new HashMap<String,Files>();
		
		try
		{
			FileInputStream file_in = new FileInputStream("stored_files/duplication");
			ObjectInputStream input = new ObjectInputStream (file_in);
			Chunk_duplications.chunk_duplications = (ArrayList<Chunk_duplications>)input.readObject();
			input.close();
			file_in.close();
		}
		catch(IOException e)
		{
			//System.out.println("Error in Stored_files.java #01");
		} 
		catch (ClassNotFoundException e) 
		{
			System.out.println("Error in Stored_files.java #02");
		}
		
		initiliaze_stored_files();
	}

	private void initiliaze_stored_files() {
		for( int i=0; i < Chunk_duplications.chunk_duplications.size();i++)
		{
			Chunk_duplications chunk_duplications = Chunk_duplications.chunk_duplications.get(i);
			
			File file = new File("stored_files/" + chunk_duplications.get_file_id() + "_" + chunk_duplications.get_chunk_number());
			
			try 
			{
				FileInputStream in = new FileInputStream(file);
				byte data[] = new byte[Constants.BODY_MAX_SIZE];
				int bytes_read = in.read(data);
				
				if( bytes_read != Constants.BODY_MAX_SIZE )
				{
					byte[] small_data = new byte[bytes_read];
					System.arraycopy(data, 0, small_data, 0, bytes_read);
					data = small_data;
				}
				
				String data_temp = new String(data);
				data_temp.trim();
				Chunk chunk = new Chunk(chunk_duplications.get_file_id(),chunk_duplications.get_chunk_number(),data_temp,chunk_duplications.get_duplication_degree());
				chunk.set_current_duplication_degree(chunk_duplications.get_current_duplication_degree());
				get_file(chunk_duplications.get_file_id()).add_chunk(chunk);
				in.close();
			} catch (FileNotFoundException e) {
				System.out.println("Error in Stored_files.java #03");
			} catch (IOException e) {
				System.out.println("Error in Stored_files.java #04");
			}
		}
	}

	public static Stored_files get_stored_files()
	{
		return stored_files;
	}

	public Files get_file(String file_id)
	{
		if( stored_files_map.containsKey(file_id) )
		{
			return stored_files_map.get(file_id);
		}
		Files file_temp = new Files(file_id);
		stored_files_map.put(file_id, file_temp);
		return file_temp;
	}

	public void add_file(Files file)
	{
		stored_files_map.put(file.get_file_id(), file);
	}

	public void delete_file(String fileId)
	{
		if(!(stored_files_map.containsKey(fileId)))
		{
			return;
		}
		Files file = stored_files_map.get(fileId);
		int chunk_number =0;
		while(file.size() > 0)
		{
			Chunk chunk = file.get_chunk(chunk_number);
			if( chunk != null )
			{
				delete_chunk(chunk);
				file.delete_chunk(chunk_number);
			}
			chunk_number++;
		}
		stored_files_map.remove(fileId);
	}

	public int return_files_total_size()
	{
		return stored_files_map.size();
	}

	public static void save_chunk(Chunk chunk) 
	{
		try
		{
			File file = new File("stored_files");
			FileWriter file_stream = new FileWriter(file.getAbsolutePath() + "/" + chunk.get_file_id() + "_" + chunk.get_chunk_number() );
			BufferedWriter out = new BufferedWriter(file_stream);
			out.write(chunk.get_data());
			out.close();
			Chunk_duplications chunkRep = new Chunk_duplications(chunk.get_file_id(), chunk.get_chunk_number(),	chunk.get_duplication_degree(), chunk.get_current_duplication_degree());
			Chunk_duplications.chunk_duplications.add(chunkRep);
			Chunk_duplications.stored_duplications();
		}
		catch (IOException e)
		{
			System.out.println("Error in Stored_files.java #05");
		}
	}

	public static void delete_chunk(Chunk chunk) {
		File file = new File("stored_files/" + chunk.get_file_id() + "_" + chunk.get_chunk_number() );
		if(!(file.delete()))
		{
			System.out.println("Error in Stored_files.java #06");
			return;
		}
		Chunk_duplications.delete_duplication(chunk.get_file_id(), chunk.get_chunk_number());
		Chunk_duplications.stored_duplications();
	}
}