package graphical_user_interface;

import java.io.IOException;
import java.nio.file.FileStore;
import java.nio.file.FileSystemException;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.nio.file.Path;
import java.text.NumberFormat;

public class Free_space {
	static long total_space;
	static long usable_space;
	
	public Free_space() throws FileSystemException{
		NumberFormat nf = NumberFormat.getNumberInstance();
		for (Path root : FileSystems.getDefault().getRootDirectories())
		{
			FileStore store = null;
			try {
				store = Files.getFileStore(root);
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
				System.exit(-1);
			}
			try {
				//System.out.println("available=" + nf.format(store.getUsableSpace()) + "\n/: total=" + nf.format(store.getTotalSpace()));
				total_space = store.getTotalSpace(); //total disk space in bytes.
				usable_space = store.getUsableSpace(); ///unallocated / free disk space in bytes.
				/*
				System.out.println(" === Partition Details ===");
				System.out.println("Path ->  " + root + ": ");
				System.out.println(" === bytes ===");
				System.out.println("Total size : " + total_space + " bytes");
				System.out.println("Space free : " + usable_space + " bytes");

				System.out.println(" === mega bytes ===");
				System.out.println("Total size : " + total_space /1024 /1024 + " mb");
				System.out.println("Space free : " + usable_space /1024 /1024 + " mb");

				System.out.println(" === giga bytes ===");
				System.out.println("Total size : " + total_space /1024 /1024 /1024 + " gb");
				System.out.println("Space free : " + usable_space /1024 /1024 /1024 + " gb");
				*/
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				System.exit(-1);
			}
		}
	}
	public static long get_total_space()
	{
		return total_space;
	}
	
	public static long get_usable_space()
	{
		return usable_space;
	}

}
