package protocol;

import java.util.ArrayList;

import multicast.*;
import constants.Constants;
import file_system.*;

public class Restore_chunk{
	private static ArrayList<Chunk> current_chunks;
	private static ArrayList<File_attributes> temp_chunks;
	public static Object temp_object;

	public Restore_chunk(){
		current_chunks = new ArrayList<Chunk>();
		temp_chunks = new ArrayList<File_attributes>();
		temp_object = new Object();
	}

	public static synchronized void delete_current_chunk(Chunk chunk){
		current_chunks.remove(chunk);
	}

	public static void add_current_chunk(Chunk chunk){
		current_chunks.add(chunk);
	}

	public static Chunk get_current_chunk(String file_id, int chunk_number){
		for(int i = 0; i < current_chunks.size(); i++){
			if(current_chunks.get(i).get_file_id().equals(file_id) &&
					current_chunks.get(i).get_chunk_number() == chunk_number){
				return current_chunks.get(i);
			}
		}
		return null;
	}

	public static synchronized boolean delete_temp_chunk(String file_id,int chunk_number)
	{
		for( int i=0; i < temp_chunks.size();i++){
			if( temp_chunks.get(i).is(file_id,chunk_number))
			{
				temp_chunks.remove(i);
				return true;
			}
		}
		return false;
	}

	public static void add_temp_chunk(String file_id, int chunk_number)
	{
		temp_chunks.add(new File_attributes(file_id, chunk_number));
	}

	public static boolean verify_temp_chunk(String file_id, int chunk_number)
	{
		for( int i=0; i < temp_chunks.size();i++){
			if( temp_chunks.get(i).is(file_id,chunk_number))
				return true;
		}
		return false;
	}

	public static void process(String packet){
		Chunk_dispatcher_2 dispatcher = new Chunk_dispatcher_2(packet);
		dispatcher.start();
	}

	public static void send_chunk(String file_id, int chunk_number, String data) {
		String header_packet = "CHUNK " + Constants.INITIAL_VERSION + " " + file_id + " " + chunk_number + Constants.CRLF() + Constants.CRLF() + data;
		Unstored_data_1.MDR().send(header_packet);

	}

	public static void get_chunk(String file_id, int chunk_number)
	{
		String packet = "GETCHUNK " + Constants.INITIAL_VERSION + " " + file_id + " " + chunk_number + Constants.CRLF() + Constants.CRLF();
		Channel_1.MC().send(packet);
	}

	public static void get_file(String file_id)
	{
		String packet = "GETFILE " + Constants.INITIAL_VERSION +  " " + file_id + " 0" + Constants.CRLF()+ Constants.CRLF();
		Chunk_dispatcher_2 dispatcher = new Chunk_dispatcher_2(packet);
		dispatcher.start();
	}
}